searchNodes=[{"doc":"Expose more user friendly API for underlying modules.","ref":"CozyParams.html","title":"CozyParams","type":"module"},{"doc":"Defines a function for casting and validating params. Essentially, this macro is just a shortcut for using CozyParams.Schema . Inspired by vic/params . Examples defmodule Demo do import CozyParams defparams :product_search do field :name , :string , required : true end def search ( params ) do with { :ok , data } &lt;- product_search ( params ) do # process data end end end Above defparams :product_search do: block will: create a module Demo.CozyParams.ProductSearch automatically. inject product_search/1 and product_search/2 into current module. And, these two functions will call Demo.CozyParams.ProductSearch.from internally. For more details of the schema definations in do: block , check out CozyParams.Schema . defparams can be used in any module, not limited to Phoenix controllers. In order to demonstrate this point, above example is using an normal Demo module, instead of a Phoenix controller. For better integration with Phoenix controllers, check out CozyParams.PhoenixController .","ref":"CozyParams.html#defparams/2","title":"CozyParams.defparams/2","type":"macro"},{"doc":"Extract error messages from %Ecto.Changeset{} .","ref":"CozyParams.html#get_error_messages/1","title":"CozyParams.get_error_messages/1","type":"function"},{"doc":"Providing macros for integrating with Phoenix controllers. Inspired by elixir-maru/maru_params . Examples Extend just a controller: defmodule DemoWeb.PageController do use DemoWeb , :controller use CozyParams.PhoenixController params :index do field :name , :string , required : true end def index ( conn , params ) do # + when external params is valid, `params` will be converted as a map with atom keys. # + when external params is invalid, an `{:error, %Ecto.Changeset{}}` will be returned, # which allows developers to handle it in the fallback controller. end end Extend all controllers: defmodule DemoWeb do # ... def controller do quote do use Phoenix.Controller , namespace : DemoWeb # ... use CozyParams.PhoenixController end end end defmodule DemoWeb.PageController do use DemoWeb , :controller params :index do field :name , :string , required : true end def index ( conn , params ) do # + when external params is valid, `params` will be converted as a map with atom keys. # + when external params is invalid, an `{:error, %Ecto.Changeset{}}` will be returned, # which allows developers to handle it in the fallback controller. end end For more details of the schema definations in do: block , check out CozyParams.Schema .","ref":"CozyParams.PhoenixController.html","title":"CozyParams.PhoenixController","type":"module"},{"doc":"Defines params for a given action .","ref":"CozyParams.PhoenixController.html#params/2","title":"CozyParams.PhoenixController.params/2","type":"macro"},{"doc":"Provides macros for defining schemas which is used for casting and validating params. Due to limitations of implementation, it's impossible to document every supported macros within @doc . Because of that, I will try to best to document them within @moduledoc . Available macros CozyParams.Schema provides a subset of macros supported by Ecto, In addition, it makes some changes on embeds_one and embeds_many . In a nutshell, all available macros are: schema(do: block) field(name, type, opts \\\\ []) available opts : :default :required - default: false embeds_one(name, opts \\\\ [], do: block) available opts : :required - default: false embeds_one(name, schema, opts \\\\ []) available opts : :required - default: false embeds_many(name, opts \\\\ [], do: block) available opts : :required - default: false embeds_many(name, schema, opts \\\\ []) available opts : :required - default: false type argument will be passed to Ecto.Schema , so it supports all the types supported by Ecto.Schema in theory. Read Types and casting section of Ecto.Schema to get more information. Examples Define a schema contains embedded fields in inline syntax: defmodule PersonParams do use CozyParams.Schema schema do field :name , :string , required : true field :age , :integer embeds_one :mate , required : true do field :name , :string , required : true field :age , :integer end embeds_many :pets do field :name , :string , required : true field :breed , :string end end end PersonParams . from ( %{ } ) Define a schema contains embedded fields with extra modules: defmodule PersonParams do use CozyParams.Schema defmodule Mate do use CozyParams.Schema schema do field :name , :string , required : true field :age , :integer end end defmodule Pet do use CozyParams.Schema schema do field :name , :string , required : true field :breed , :string end end schema do field :name , :string , required : true field :age , :integer embeds_one :mate , Mate , required : true embeds_many :pets , Pet end end PersonParams . from ( %{ } ) About the generated functions schema/1 will create 2 functions automatically: changeset/2 which is overridable. from/1 / from/2 which will be called by high-level abstractions, such as CozyParams , CozyParams.PhoenixController . You can specify the type of return value of from/2 : PersonParams . from ( %{ } , type : :struct ) # %PersonParams{} PersonParams . from ( %{ } , type : :map ) # %{}","ref":"CozyParams.Schema.html","title":"CozyParams.Schema","type":"module"},{"doc":"","ref":"CozyParams.Schema.html#schema/1","title":"CozyParams.Schema.schema/1","type":"macro"},{"doc":"Process the AST of CozyParams .","ref":"CozyParams.Schema.AST.html","title":"CozyParams.Schema.AST","type":"module"},{"doc":"Make sure that the AST is always a block.","ref":"CozyParams.Schema.AST.html#as_block/1","title":"CozyParams.Schema.AST.as_block/1","type":"function"},{"doc":"Transform cozy_params supported AST to ecto supported AST. Currently, this function will: drop options which are supported by cozy_params only. Or, ecto will report invalid option errors.","ref":"CozyParams.Schema.AST.html#as_ecto_block/1","title":"CozyParams.Schema.AST.as_ecto_block/1","type":"function"},{"doc":"Extract embeds from AST.","ref":"CozyParams.Schema.AST.html#extract_embeds/1","title":"CozyParams.Schema.AST.extract_embeds/1","type":"function"},{"doc":"Extract fields from AST.","ref":"CozyParams.Schema.AST.html#extract_fields/1","title":"CozyParams.Schema.AST.extract_fields/1","type":"function"},{"doc":"Transpile shortcuts of embeds_one and embeds_many . cozy_params will transpile code like following one: embeds_one :address , required : true do field :latitude , :float , required : true field :longtitude , :float , required : true end to Ecto supported code: defmodule Address do use CozyParams.Schema schema do field :latitude , :float , required : true field :longtitude , :float , required : true end end embeds_one :address , Address","ref":"CozyParams.Schema.AST.html#transpile_block/2","title":"CozyParams.Schema.AST.transpile_block/2","type":"function"},{"doc":"Validate if the block meets cozy_params 's requirements. Although cozy_params try its best to emulate the API of Ecto.Schema , but it doesn't mean that every API of Ecto.Schema is supported by cozy_params . Because of that, cozy_params validates the calls before proceeding.","ref":"CozyParams.Schema.AST.html#validate_block!/1","title":"CozyParams.Schema.AST.validate_block!/1","type":"function"},{"doc":"Provides Ecto-like API for casting and validating params.","ref":"readme.html","title":"CozyParams","type":"extras"},{"doc":"There are some packages in the community: NAME Based on Ecto? Use Ecto-like API? params YES NO maru_params NO NO tarams NO NO ... But, they don't fit my requirements. The package in my dream should: be based on Ecto which is robust and battle-tested. use Ecto-like API, which eliminates friction when working on casting params and modeling data source at the same time.","ref":"readme.html#why-another-package","title":"CozyParams - Why another package?","type":"extras"},{"doc":"Add cozy_params to your list of dependencies in mix.exs : def deps do [ { :cozy_params , &quot;~&gt; 0.1.0&quot; } ] end (Optional) And, it's encouraged to setup .formatter.exs for cozy_params : [ import_deps : [ # ... :cozy_params ] , # ... ]","ref":"readme.html#installation","title":"CozyParams - Installation","type":"extras"},{"doc":"CozyParams - provides macros for general usage. For better integration with other libraries: CozyParams.PhoenixController ... CozyParams.Schema - the module at lowest level. Generally, you don't use it directly. Visit HexDocs for more details.","ref":"readme.html#overview","title":"CozyParams - Overview","type":"extras"},{"doc":"If you want to use cozy_params with phoenix controllers, use CozyParams.PhoenixController . If you want to use cozy_params in other cases, use CozyParams . If you want to know how cozy_params works, explore CozyParams.Schema .","ref":"readme.html#which-module-should-i-use","title":"CozyParams - Which module should I use?","type":"extras"},{"doc":"You can try: params maru_params tarams params.ex from imranismail Find more at hex.pm .","ref":"readme.html#uhhh-i-don-t-like-it","title":"CozyParams - uhhh... I don't like it","type":"extras"},{"doc":"Apache License 2.0","ref":"readme.html#license","title":"CozyParams - License","type":"extras"},{"doc":"","ref":"faq.html","title":"FAQ","type":"extras"},{"doc":"By default, CozyParams just: casts types of fields. validates presence of fields. But, people usually expect more, such as validating format, etc. The easiest way is to override changeset/2 in a schema. For example: defmodule SampleParams do use CozyParams.Schema schema do field :name , :string , required : true field :age , :integer embeds_one :mate , required : true do field :name , :string , required : true field :age , :integer end embeds_many :pets do field :name , :string , required : true field :breed , :string end end def changeset ( struct , params ) do struct |&gt; super ( params ) |&gt; Ecto.Changeset . validate_ * # ... end end A harder way is to extend CozyParams.Schema at AST level, which requires you to improve CozyParams.Schema.AST .","ref":"faq.html#how-to-expand-the-capabilities-of-schemas","title":"FAQ - How to expand the capabilities of schemas?","type":"extras"},{"doc":"All checking functions of CozyParams will return {:error, %Ecto.Changest{}} as error. You can pattern match the data structure, and convert the changeset as error messages by using CozyParams.get_error_messages/1 . For example, in a Phoenix project, you can do that in the fallback controller: defmodule DemoWeb.FallbackController do use DemoWeb , :controller # ... def call ( conn , { :error , % Ecto.Changeset { } = changeset } ) do messages = CozyParams . get_error_messages ( changeset ) # ... end # ... end","ref":"faq.html#how-to-handle-the-errors-returned-by-cozyparams","title":"FAQ - How to handle the errors returned by CozyParams?","type":"extras"}]